//+------------------------------------------------------------------+
//|                                                Candles Works.mq4 |
//|                                      Copyright  2006, Eli Hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli Hayun"
#property link      "http://www.elihayun.com"

#define DOWN_TREND -1
#define UP_TREND    1
#define NEUTRAL     0



extern double lots=1.0;
extern int MaxTrades=1;
extern bool ManageMoney = true;
extern int Risk = 2;
extern bool ProfitTrailing = true;  
extern bool UseSound = true;  

extern int StopLoss = 30;
extern int TakeProfit = 10;
extern int TrailingStop = 8; 

extern int timeframe = 0;
  
int TrailingStep = 1;   
string NameFileSound  = "expert.wav";  

int MagicNum = 12355;
void deinit() {
   Comment("");
}

//--------------------------------------------------------------------------------------// 

void CloseOrders(){
int cnt=0;
int tik[30];
bool B;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && MagicNum==OrderMagicNumber())
         {  B = OrderProfit() < -30;
            if (OrderProfit() < -300)
            {
               Print("Order # " , OrderTicket(), " has " , OrderProfit(), " and will be close ",B);
               //tik[cnt] = OrderTicket();
               //cnt++;
            }
         }
      }
   }
   for (i = 0; i<cnt; i++)
   {
      double prc = Bid;
      
      OrderSelect(tik[i], SELECT_BY_TICKET);
      if (OrderType() == OP_SELL)
         prc = Ask;
      OrderClose(tik[i], OrderLots(), prc, 3, Blue);
   }
}

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && MagicNum==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start()
{
   static bool ftime = true;
   if (ftime)
   {
      ftime = false;
      Print(TimeToStr(Time[0]));
   }
   
   int m = Minute();   
   int d = (m + 1) / Period();
   
   if ( d * Period() != (m+1))  // check 5 minutes before the bar end
   {
    //  return(0);
   }     
   
   if (!NewBar())
      return(0);
      
   CloseOrders();
   CheckCandles(1);
//   return(0);
   
   for (int i=0; i<OrdersTotal(); i++) {
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         TrailingPositions();
      }
   }

   if(orderscnt()<MaxTrades){
      if(ManageMoney==true) lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){

  bool Buy = false, Sell=false;

   Buy  = CheckBuySell(OP_BUY, 1);
   Sell = CheckBuySell(OP_SELL,1);

  
   double TP,SL;
   double ema3, ema5;
   ema3 = iMA(NULL,60,3,0,MODE_EMA,PRICE_CLOSE,0);
   ema5 = iMA(NULL,60,5,0,MODE_EMA,PRICE_CLOSE,0);
//--------------------------------------------------------------------------------------// 
   if (Buy && (ema3>ema5)){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"CWK "+Period(),MagicNum,0,LawnGreen); 
   }
   if (Sell && (ema3<ema5)){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"CWK "+Period(),MagicNum,0,HotPink); 
   }
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/10;  
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderMagicNumber() != MagicNum)
   return;
  
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  if (OrderMagicNumber() != MagicNum)
   return;
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 

bool NewBar()
{

   static datetime dt = 0;
   if (iTime(NULL,timeframe, 0) != dt)
   {
      dt = iTime(NULL,timeframe, 0);
      //Print(TimeToStr(dt),"  ");
      return(true);
   }
   return(false);
}
/*
void DrawLine(color clr)
{
   static int ix = 1;
   ObjectCreate("ln"+ix, OBJ_VLINE, 0, iTime(NULL, timeframe, 0), Ask);
   ObjectSet("ln"+ix, OBJPROP_COLOR, clr);
   ix++;
   
}
*/
// add logic here 
// CheckBuySell will check if it is safe to buy or safe to sell according to op parameter
// op : OP_BUY or OP_SELL
bool CheckBuySell(int op, int ii)
{
   double oo[5], cc[5], hh[5], ll[5];
   
   for(int i=0; i<5; i++)
   {
      oo[i] = iOpen(NULL, timeframe, i);
      cc[i] = iClose(NULL, timeframe, i);
      hh[i] = iHigh(NULL, timeframe, i);
      ll[i] = iLow(NULL, timeframe, i);
   }
   
   int head = (hh[1] - MathMax(oo[1], cc[1])) / Point;
   int tail = (MathMin(oo[1], cc[1]) - ll[1]) / Point;
   int body = MathAbs(oo[1]-cc[1]) / Point;
   
   if (op == OP_BUY)
   {
      if ( (oo[1] < cc[1]) && (oo[2] < cc[2]) && (oo[3] > cc[3]) )
         if ((head < 3) || (head < body))  // make sure we don't have long candle head
            return(true);
   }
   
   if (op == OP_SELL)
   {
      if ( (oo[1] > cc[1]) && (oo[2] > cc[2]) && (oo[3] < cc[3]) )
        if ((tail<3) || (tail < body))  // make sure we don't have long candle tail
            return(true);
   }
   return(false);
}


void CheckCandles(int ii)
{

}